; Barcode 128B
;~~~~~~~~~~~~~~

EnableExplicit

XIncludeFile "CT_Barcode.pbi"

;{- Konstanten

Enumeration
   #Win
   #Bar
   #Txt
   #Btn
   #Menu
   #Exit
   #Print
EndEnumeration

#WinWidth    = 300

;} Endkonstanten

ctUseBarcode()

Procedure MainWindow_Create()
   
   If OpenWindow(#Win, 0, 0, #WinWidth, (#WinWidth * 0.3 + 20), "Barcode 128", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
      If CreateMenu(#Menu, WindowID(#Win))
         MenuItem(#Exit , "Exit")
         MenuItem(#Print, "Drucken")
         DisableMenuItem(#Menu, #Print, #True)
      EndIf
      StringGadget(#Txt, 010, 05, 100, 20, "040000769458734")
      ButtonGadget(#Btn, 115, 05, 060, 20, "Barcode")
      CanvasGadget(#Bar, 010, 30, (#WinWidth - 20), (#WinWidth * 0.3 - 35), #PB_Canvas_Border)
      SetActiveGadget(#Txt)
   EndIf
EndProcedure    
    
Procedure Main()
   Protected n.i, pX.i = 200, pY.i = 200, pWidth.i, pSpan.i = 50
   Protected pQuit.a, pEvent.i
   
   MainWindow_Create()
   Repeat
      pEvent = WaitWindowEvent()
      Select pEvent
         Case #PB_Event_CloseWindow: pQuit = #True   
         Case #PB_Event_Gadget
            If (EventGadget()=#btn): ctBarcode_ScreenGenerate(#Bar, GetGadgetText(#Txt)): DisableMenuItem(#menu, #Print, #False): EndIf
         Case #PB_Event_Menu
            Select EventMenu()
               Case #Exit: pQuit = #True
               Case #Print
                  If PrintRequester()
                     If StartPrinting("Barcode128")
                        ctBarcode_PrintGenerate(GetGadgetText(#Txt), pX, pY)
                        If StartDrawing(PrinterOutput())
                           pWidth  =  ctBarcode_PrintWidth(GetGadgetText(#Txt))
                           DrawingMode(#PB_2DDrawing_Outlined)
                           Box((pX - pSpan), (pY - pSpan), (pWidth + 2 * pSpan), (ctBarcode_PrintHeight() + 2 * pSpan), #Blue)
                           StopDrawing()
                        EndIf
                        StopPrinting()
                     EndIf   
                  EndIf
            EndSelect
      EndSelect
   Until pQuit
EndProcedure

Main()

End 
